<p align="center">
  <a href="https://velocityx.dev/" target="_blank">
    <img src="https://i.imgur.com/GcsbeIW.png"  width="800" alt="VelocityX">
  </a>
</p>
<a href="https://www.producthunt.com/posts/velocityx?utm_source=badge-featured&utm_medium=badge&utm_souce=badge-velocityx" target="_blank"><img src="https://api.producthunt.com/widgets/embed-image/v1/featured.svg?post_id=289488&theme=light" alt="VelocityX - A minimalist Flutter framework | Product Hunt" style="width: 250px; height: 54px;" width="250" height="54" /></a>

[![VelocityX](https://img.shields.io/badge/velocityx-fast-red)](https://github.com/iampawan/velocityx)
[![Pub release](https://img.shields.io/pub/v/velocity_x.svg?style=flat-square)](https://pub.dev/packages/velocity_x)
[![GitHub Release Date](https://img.shields.io/github/release-date/iampawan/velocityx.svg?style=flat-square)](https://github.com/iampawan/velocityx)
[![GitHub issues](https://img.shields.io/github/issues/iampawan/velocityx.svg?style=flat-square)](https://github.com/iampawan/velocityx/issues)
[![GitHub top language](https://img.shields.io/github/languages/top/iampawan/velocityx.svg?style=flat-square)](https://github.com/iampawan/velocityx)
[![Likes](https://badges.bar/velocity_x/likes)](https://pub.dev/packages/velocity_x/score)
[![Popularity](https://badges.bar/velocity_x/popularity)](https://pub.dev/packages/velocity_x/score)
<a href="https://discord.gg/9tXYvNq"><img src="https://img.shields.io/discord/746087597759004835.svg?logo=discord&color=blue" alt="Discord"></a>

### Show some :heart: and star the repo.

[![GitHub followers](https://img.shields.io/github/followers/iampawan.svg?style=social&label=Follow)](https://github.com/iampawan/)
[![Twitter Follow](https://img.shields.io/twitter/follow/imthepk.svg?style=social)](https://twitter.com/imthepk)

[![Open Source Love](https://badges.frapsoft.com/os/v1/open-source.svg?v=102)](https://opensource.org/licenses/Apache-2.0)

---

## [Demo App](https://vx-demo.web.app/)

## [Subscribe to Codepur](https://codepur.dev/)

---

[**VelocityX**](https://velocityx.dev/) is a 100% free Flutter open-source minimalist UI Framework built with <a href="https://flutter.dev/" target="_blank">Flutter SDK</a> to make Flutter development easier and more joyful than ever.

## Inspired from Tailwindcss and SwiftUI.

```dart
"Welcome to VelocityX".text.white.xl4.bold.center.makeCentered().box.roundedLg.red500.shadow2xl.make().whHalf(context).centered();
```

---

## Getting started

In the `pubspec.yaml` of your flutter project, add the following dependency:

```yaml
dependencies:
  ...
  velocity_x: <latest_version>
```

In your library add the following import:

```dart
import 'package:velocity_x/velocity_x.dart';
```

For help getting started with Flutter, view the online [documentation](https://velocityx.dev/docs/install).

---

### 📌 &nbsp; Bulletin

- Now supports null-safety
- [Video Tutorials on YouTube](https://www.youtube.com/watch?v=IOhJCN4T1V4&list=PLR2qQy0Zxs_UHLXSYbK50jEapx0ORmLYv) for updates & walk through videos.
- [Join the discord](https://discord.gg/9tXYvNq)

## Why use VelocityX?

VelocityX is known for :

| Vx                                 | Vx                          |
| :--------------------------------- | :-------------------------- |
| 100% fast, performant & compatible | 100% free & open-source     |
| 100% ready for production          | 200% faster for writing UIs |

---

## Features

✅ &nbsp; [State Management](https://velocityx.dev/docs/vxstate/getting_started) </br>
✅ &nbsp; [Navigator 2.0](https://velocityx.dev/docs/vxnavigator/getting_started)  
✅ &nbsp; [Custom UIs](https://velocityx.dev/docs/install)  
✅ &nbsp; [Custom Shapes](https://velocityx.dev/docs/shapes/vxcircle)  
✅ &nbsp; [Super VX](https://velocityx.dev/docs/supervx/vxswiper)  
✅ &nbsp; [Extension Methods](https://velocityx.dev/docs/extensions/context)  
✅ &nbsp; [Responsive Layout](https://velocityx.dev/docs/features/responsive)  
✅ &nbsp; [Color Palette](https://velocityx.dev/docs/colors)

# Quick start

Read the [Getting started page of VelocityX](https://velocityx.dev/docs/install)

## VelocityX Video Tutorials

[Watch here](https://www.youtube.com/playlist?list=PLR2qQy0Zxs_UHLXSYbK50jEapx0ORmLYv)

---

<a href="https://www.buymeacoffee.com/mtechviral"><img src="https://cdn.buymeacoffee.com/buttons/v2/default-yellow.png"></a>

---

## Some popular Super Vx widgets

| [VxShapes](https://velocityx.dev/docs/shapes/vxcircle) | [VxSwiper](https://velocityx.dev/docs/supervx/vxswiper) | [VxResponsive](https://velocityx.dev/docs/features/responsive) | [VxPlatform](https://velocityx.dev/docs/supervx/vxplatform) | [VxToast](https://velocityx.dev/docs/supervx/vxtoast) | [VxRating](https://velocityx.dev/docs/supervx/vxrating) | [VxStepper](https://velocityx.dev/docs/supervx/vxstepper) |

## Some Quick UIs made using VelocityX

<p float="left">
<img src="https://i.imgur.com/DlSuaOG.png" width="500"/>
<img src="https://i.imgur.com/JZ9tOoy.png" width="500"/>
<img src="https://i.imgur.com/JFpw795.png" width="500"/>
<img src="https://i.imgur.com/nuGnpG1.png" width="500"/>
<img src="https://i.imgur.com/DlSuaOG.png" width="500"/>
<img src="https://i.imgur.com/41kZ4Hd.png" width="500"/>
</p>

## Contributing

VelocityX is **100% free** and **open source**. We encourage and support an active, healthy community that accepts contributions from the public &ndash; including you. There are a couple of ways in which you can contribute to the growing community of `VelocityX`.

- Pick up any issue marked with ["good first issue"](https://github.com/iampawan/velocityx/issues?q=is%3Aopen+is%3Aissue+label%3A%22good+first+issue%22)
- Fix a bug
- Write and improve some **documentation**. Documentation is very critical to us. We would appreciate help in adding multiple languages to our docs.
- If you are a developer, feel free to check out the source and submit pull requests.
- Dig into [**CONTRIBUTING.MD**](CONTRIBUTING.md), which covers submitting bugs, requesting new features, preparing your code for a pull request, etc.
- Please don't forget to **like**, **follow**, and **star our repo**!

# Documentation

[**Installation Guide**](https://velocityx.dev/docs/install)

### :heart: Found this project useful?

If you found this project useful, then please consider giving it a :star: on Github and sharing it with your friends via social media.

---

### YouTube Channel

[Codepur](https://www.youtube.com/hellocodepur) </br>
[Codepur Hindi](https://www.youtube.com/hindicodepur)

### Facebook Group

[Let's Flutter With Dart](https://www.facebook.com/groups/425920117856409/)

### Collection of flutter apps with tutorial

[Flutter Example Apps](https://github.com/iampawan/FlutterExampleApps)

---

## Project Created & Maintained By

### Pawan Kumar

Google Developer Expert for Flutter. Passionate #Flutter, #Android Developer. #Entrepreneur #YouTuber

<a href="https://play.google.com/store/apps/dev?id=7703305844118303242&hl=en"><img src="https://github.com/aritraroy/social-icons/blob/master/play-store-icon.png?raw=true" width="60"></a> <a href="https://medium.com/@imthepk"><img src="https://github.com/aritraroy/social-icons/blob/master/medium-icon.png?raw=true" width="60"></a>
<a href="https://twitter.com/imthepk"><img src="https://github.com/aritraroy/social-icons/blob/master/twitter-icon.png?raw=true" width="60"></a>
<a href="https://linkedin.com/in/imthepk"><img src="https://github.com/aritraroy/social-icons/blob/master/linkedin-icon.png?raw=true" width="60"></a>
<a href="https://facebook.com/imthepk"><img src="https://github.com/aritraroy/social-icons/blob/master/facebook-icon.png?raw=true" width="60"></a>
<a href="https://instagram.com/codepur_ka_superhero"><img src="https://github.com/aritraroy/social-icons/blob/master/instagram-icon.png?raw=true" width="60"></a>

# Donate

> If you found this project helpful or you learned something from the source code and want to thank me, consider buying me a cup of :coffee:
>
> - [PayPal](https://www.paypal.me/imthepk/)

### Note: VelocityX is not directly and/or indirectly associated/affiliated with Flutter or Google LLC.

## Active Contributors

1. Ayush Bherwani
1. Hasnen Tai
1. Harpreet Singh

## Copyright-and-license

Code and documentation Copyright 2020 [Pawan Kumar](https://pawan.live). Code released under the [Apache License](./LICENSE). Docs released under [Creative Commons](https://creativecommons.org/licenses/by/3.0/).
